from PyQt5 import QtCore

from Gopass import Gopass
from fuzzyfinder import fuzzyfinder

SERVICE = "gopassClient"

class OTPModel(QtCore.QObject):
    _name=""
    def __init__(self,name):
        QtCore.QObject.__init__(self)
        self._name=name

    nameChanged = QtCore.pyqtSignal()
    @QtCore.pyqtProperty(str,notify=nameChanged)
    def name(self):
        return self._name;

    @QtCore.pyqtSlot()
    def getOTPCode(self):
        print(self._name)
        Gopass.getPass(self._name)


class OPTListModel(QtCore.QAbstractListModel):
    _items=[]
    def __init__(self,parent = None):
        QtCore.QAbstractListModel.__init__(self, parent)

    def setup(self, list):
        self._items = list

    def load(self):
        size = len(self._items)
        self._items = []
        passwords = Gopass.getPasses()
        for password in passwords:
            self._items.append(OTPModel(password))
        self.modelReset.emit()

    @QtCore.pyqtSlot(str)
    def addItem(self, name=""):
        self._items.append(OTPModel(name))
        self.modelReset.emit()
        self.save()

    @QtCore.pyqtSlot(int,result=object)
    def getItem(self,index):
        return self._items[index]

    def rowCount(self, parent=QtCore.QModelIndex()):
        return len(self._items)

    def setData(self, index, value, role):
        self._items[index.row()] = value
        self.dataChanged.emit(index, index)
        return True

    def flags(self, index):
        return QtCore.Qt.ItemIsEditable | QtCore.Qt.ItemIsEnabled | QtCore.Qt.ItemIsSelectable

    def data(self, index, role=QtCore.Qt.DisplayRole):
        if role == QtCore.Qt.DisplayRole:
            return self._items[index.row()]
        else:
            return None

    @QtCore.pyqtSlot(str)
    def fuzzyChanged(self, inputtxt):
        self._items = []
        files = Gopass.getPasses()
        suggestions = list(fuzzyfinder(inputtxt, files))
        for suggestion in suggestions:
            self._items.append(OTPModel(suggestion))

        self.modelReset.emit()

